From 4dbf8cf04b0e1f38743f08c0d14416fe77e7cd05 Mon Sep 17 00:00:00 2001
From: Angelo Schiavone <angelo.schiavone@screen.it>
Date: Thu, 24 Jan 2013 08:52:11 +0100
Subject: [PATCH] fixes NIT and BAT descriptors loop decoding, p_end is now
 correctly calculated

---
 src/tables/bat.c |    2 +-
 src/tables/nit.c |    2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

diff --git a/src/tables/bat.c b/src/tables/bat.c
index 9811795..efda516 100644
--- a/src/tables/bat.c
+++ b/src/tables/bat.c
@@ -489,7 +489,7 @@ void dvbpsi_bat_sections_decode(dvbpsi_bat_t* p_bat,
             p_byte += 2 + i_length;
         }
 
-        p_end = p_byte + (((uint16_t)(p_byte[0] & 0x0f) << 8)
+        p_end = 2 + p_byte + (((uint16_t)(p_byte[0] & 0x0f) << 8)
                           | p_byte[1]);
         if (p_end > p_section->p_payload_end)
             p_end = p_section->p_payload_end;
diff --git a/src/tables/nit.c b/src/tables/nit.c
index 1532e3d..dce830e 100644
--- a/src/tables/nit.c
+++ b/src/tables/nit.c
@@ -474,7 +474,7 @@ void dvbpsi_nit_sections_decode(dvbpsi_nit_t* p_nit,
         }
 
         /* Transport stream loop length */
-        p_end = p_byte + (((uint16_t)(p_byte[0] & 0x0f) << 8)
+        p_end = 2 + p_byte + (((uint16_t)(p_byte[0] & 0x0f) << 8)
                           | p_byte[1]);
         if (p_end > p_section->p_payload_end)
             p_end = p_section->p_payload_end;
-- 
1.7.9.5
